<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Accessories: ACCSCHAINEDLIST&lt; T &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Accessories
   </div>
   <div id="projectbrief">Arduino for motors and lights library.</div>
  </td>
   <td>        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
</td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classACCSCHAINEDLIST.html','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-attribs">Public Attributes</a> &#124;
<a href="classACCSCHAINEDLIST-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">ACCSCHAINEDLIST&lt; T &gt; Class Template Reference</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">

<p><code>#include &quot;<a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>&quot;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:ae5d313f656e6ad183f5071024b994452"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classACCSCHAINEDLIST.html#ae5d313f656e6ad183f5071024b994452">ACCSCHAINEDLIST</a> ()</td></tr>
<tr class="separator:ae5d313f656e6ad183f5071024b994452"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a57717781c95414794910f53b0500ea3d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classACCSCHAINEDLIST.html#a57717781c95414794910f53b0500ea3d">AddItem</a> (T *t)</td></tr>
<tr class="separator:a57717781c95414794910f53b0500ea3d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5b7ce14101b3e2bb6c6ed1a515a8ba93"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classACCSCHAINEDLIST.html#a5b7ce14101b3e2bb6c6ed1a515a8ba93">NextCurrent</a> ()</td></tr>
<tr class="separator:a5b7ce14101b3e2bb6c6ed1a515a8ba93"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac7147ad27413bf0439855df743886053"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classACCSCHAINEDLIST.html#ac7147ad27413bf0439855df743886053">ResetCurrent</a> ()</td></tr>
<tr class="separator:ac7147ad27413bf0439855df743886053"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad621d76251ac543fc892420f98d704ba"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classACCSCHAINEDLIST.html#ad621d76251ac543fc892420f98d704ba">StartCurrent</a> ()</td></tr>
<tr class="separator:ad621d76251ac543fc892420f98d704ba"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aec3d93b7e6c96031af848629d72905bd"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classACCSCHAINEDLIST.html#aec3d93b7e6c96031af848629d72905bd">HasCurrent</a> ()</td></tr>
<tr class="separator:aec3d93b7e6c96031af848629d72905bd"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-attribs"></a>
Public Attributes</h2></td></tr>
<tr class="memitem:a023941d1bf9661dd5f939575eb946bb2"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM</a>&lt; T &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classACCSCHAINEDLIST.html#a023941d1bf9661dd5f939575eb946bb2">pFirst</a></td></tr>
<tr class="separator:a023941d1bf9661dd5f939575eb946bb2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a154d3c5354d97450a9184551691661cc"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM</a>&lt; T &gt; *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classACCSCHAINEDLIST.html#a154d3c5354d97450a9184551691661cc">pCurrentItem</a></td></tr>
<tr class="separator:a154d3c5354d97450a9184551691661cc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8048782bdfd21cd416e50149973a952f"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classACCSCHAINEDLIST.html#a8048782bdfd21cd416e50149973a952f">HasCurrentNull</a></td></tr>
<tr class="separator:a8048782bdfd21cd416e50149973a952f"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;class T&gt;<br />
class ACCSCHAINEDLIST&lt; T &gt;</h3>

<p>This class describes a chained list of items (<a href="https://en.wikipedia.org/wiki/Linked_list">https://en.wikipedia.org/wiki/Linked_list</a>). It can be called also a linked list. This is an elegant way to build a list without any big allocation, bypassing the needs to estimate a minimum size and to increase or decrease this size during execution. The disavantage is a slower and more complex way to access to an item on the list, and a more complex way to add a new item.</p>
<p>To start, a chained list needs a starting pointer referencing the first item of the list. After that, each item have a pointer to the next item. If this pointer is NULL, this is the end of the list !</p>
<p>The 'T' type can be of any type, including base types like int or char. But keep in mind that each item must save a pointer to the next item. If the size of the pointer is greater than the size of the item itself, consider using a true array...</p>
<p>A notion of 'current item' is used, to let the user of the list to move through the list without doing a loop itself... </p>

<p class="definition">Definition at line <a class="el" href="Chain_8hpp_source.html#l00033">33</a> of file <a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>.</p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ae5d313f656e6ad183f5071024b994452"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">ACCSCHAINEDLIST&lt; T &gt;::ACCSCHAINEDLIST </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Default constructor. </p>

<p class="definition">Definition at line <a class="el" href="Chain_8hpp_source.html#l00044">44</a> of file <a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a57717781c95414794910f53b0500ea3d"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void ACCSCHAINEDLIST&lt; T &gt;::AddItem </td>
          <td>(</td>
          <td class="paramtype">T *&#160;</td>
          <td class="paramname"><em>t</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Add a new item to the list. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">t</td><td>Address of the item to add. </td></tr>
  </table>
  </dd>
</dl>

<p class="definition">Definition at line <a class="el" href="Chain_8hpp_source.html#l00071">71</a> of file <a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="aec3d93b7e6c96031af848629d72905bd"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool ACCSCHAINEDLIST&lt; T &gt;::HasCurrent </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Checks if the current is NULL. </p><dl class="section return"><dt>Returns</dt><dd>True if the curent item is NULL. </dd></dl>

<p class="definition">Definition at line <a class="el" href="Chain_8hpp_source.html#l00059">59</a> of file <a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a5b7ce14101b3e2bb6c6ed1a515a8ba93"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void ACCSCHAINEDLIST&lt; T &gt;::NextCurrent </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Move the current pointer to the next one in the list. If the current was the last one, the current pointer will be set to the start of the list, its first item. </p>

<p class="definition">Definition at line <a class="el" href="Chain_8hpp_source.html#l00099">99</a> of file <a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="ac7147ad27413bf0439855df743886053"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void ACCSCHAINEDLIST&lt; T &gt;::ResetCurrent </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Reset the current item to the first of the list, or NULL if <a class="el" href="classACCSCHAINEDLIST.html#a8048782bdfd21cd416e50149973a952f">HasCurrentNull</a> is true. </p>

<p class="definition">Definition at line <a class="el" href="Chain_8hpp_source.html#l00053">53</a> of file <a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="ad621d76251ac543fc892420f98d704ba"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void ACCSCHAINEDLIST&lt; T &gt;::StartCurrent </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Reset the current item to the first of the list. </p>

<p class="definition">Definition at line <a class="el" href="Chain_8hpp_source.html#l00055">55</a> of file <a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>.</p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a class="anchor" id="a8048782bdfd21cd416e50149973a952f"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool ACCSCHAINEDLIST&lt; T &gt;::HasCurrentNull</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>If true, the current pointer is null when all items has been used. </p>

<p class="definition">Definition at line <a class="el" href="Chain_8hpp_source.html#l00041">41</a> of file <a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a154d3c5354d97450a9184551691661cc"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM</a>&lt;T&gt;* ACCSCHAINEDLIST&lt; T &gt;::pCurrentItem</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Address of current item in the chain, or NULL for none. </p>

<p class="definition">Definition at line <a class="el" href="Chain_8hpp_source.html#l00039">39</a> of file <a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>.</p>

</div>
</div>
<a class="anchor" id="a023941d1bf9661dd5f939575eb946bb2"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classACCSCHAINEDLISTITEM.html">ACCSCHAINEDLISTITEM</a>&lt;T&gt;* ACCSCHAINEDLIST&lt; T &gt;::pFirst</td>
        </tr>
      </table>
</div><div class="memdoc">
<p>Address of next element in chain, or NULL for none. In this case the list is empty. </p>

<p class="definition">Definition at line <a class="el" href="Chain_8hpp_source.html#l00037">37</a> of file <a class="el" href="Chain_8hpp_source.html">Chain.hpp</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>D:/Mes documents/Trusty/Arduino/Libraries/Accessories/src/<a class="el" href="Chain_8hpp_source.html">Chain.hpp</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="classACCSCHAINEDLIST.html">ACCSCHAINEDLIST</a></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:44:46 for Accessories &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
